diff -aruN --binary 18/administrator/components/com_admin/admin.admin.html.php 20/administrator/components/com_admin/admin.admin.html.php
--- 18/administrator/components/com_admin/admin.admin.html.php	2010-04-23 13:40:10.000000000 +0200
+++ 20/administrator/components/com_admin/admin.admin.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: admin.admin.html.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: admin.admin.html.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Admin
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -137,6 +137,8 @@
 		$fullhelpurl = $helpurl . '/index2.php?option=com_content&amp;task=findkey&amp;pop=1&amp;keyref=';
 
 		$helpsearch = JRequest::getString('helpsearch');
+		$helpsearch = str_replace(array('=', '<', '"'), '', $helpsearch);
+
 		$page		= JRequest::getCmd('page', 'joomla.whatsnew15.html');
 		$toc		= getHelpToc( $helpsearch );
 		$lang		=& JFactory::getLanguage();
@@ -159,7 +161,7 @@
 						<td>
 							<strong><?php echo JText::_( 'Search' ); ?>:</strong>
 							<input class="text_area" type="hidden" name="option" value="com_admin" />
-							<input type="text" name="helpsearch" value="<?php echo $helpsearch;?>" class="inputbox" />
+							<input type="text" name="helpsearch" value="<?php echo htmlspecialchars($helpsearch);?>" class="inputbox" />
 							<input type="submit" value="<?php echo JText::_( 'Go' ); ?>" class="button" />
 							<input type="button" value="<?php echo JText::_( 'Clear Results' ); ?>" class="button" onclick="f=document.adminForm;f.helpsearch.value='';f.submit()" />
 						</td>
diff -aruN --binary 18/administrator/components/com_banners/controllers/banner.php 20/administrator/components/com_banners/controllers/banner.php
--- 18/administrator/components/com_banners/controllers/banner.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_banners/controllers/banner.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: banner.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: banner.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Banners
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -78,6 +78,12 @@
 		}
 
 		$where		= count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '';
+
+		// sanitize $filter_order
+		if (!in_array($filter_order, array('b.name', 'c.name', 'cc.title', 'b.showBanner', 'b.ordering', 'b.sticky', 'b.impmade', 'b.clicks', 'b.bid'))) {
+			$filter_order = 'cc.title';
+		}
+
 		$orderby	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', b.ordering';
 
 		// get the total number of records
diff -aruN --binary 18/administrator/components/com_banners/controllers/client.php 20/administrator/components/com_banners/controllers/client.php
--- 18/administrator/components/com_banners/controllers/client.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_banners/controllers/client.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: client.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: client.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Banners
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -59,6 +59,11 @@
 		}
 
 		$where		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
+
+		if (!in_array($filter_order, array('a.name', 'a.contact', 'bid', 'a.cid'))) {
+			$filter_order = 'a.name';
+		}
+
 		$orderby = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', a.cid';
 
 		// get the total number of records
diff -aruN --binary 18/administrator/components/com_banners/views/banner.php 20/administrator/components/com_banners/views/banner.php
--- 18/administrator/components/com_banners/views/banner.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_banners/views/banner.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: banner.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: banner.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Banners
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -139,25 +139,25 @@
 						<?php echo $checked; ?>
 					</td>
 					<td>
-					<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit' );?>::<?php echo $row->name; ?>">
+					<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit' );?>::<?php echo htmlspecialchars($row->name); ?>">
 						<?php
 						if ( JTable::isCheckedOut($user->get ('id'), $row->checked_out ) ) {
-							echo $row->name;
+							echo htmlspecialchars($row->name);
 						} else {
 							?>
 
 							<a href="<?php echo $link; ?>">
-								<?php echo $row->name; ?></a>
+								<?php echo htmlspecialchars($row->name); ?></a>
 							<?php
 						}
 						?>
 						</span>
 					</td>
 					<td align="center">
-						<?php echo $row->client_name;?>
+						<?php echo htmlspecialchars($row->client_name);?>
 					</td>
 					<td align="center">
-						<?php echo $row->category_name;?>
+						<?php echo htmlspecialchars($row->category_name);?>
 					</td>
 					<td align="center">
 						<?php echo $published;?>
diff -aruN --binary 18/administrator/components/com_banners/views/client.php 20/administrator/components/com_banners/views/client.php
--- 18/administrator/components/com_banners/views/client.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_banners/views/client.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: client.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: client.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Banners
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -102,9 +102,9 @@
 							echo $row->name;
 						} else {
 							?>
-								<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit' );?>::<?php echo $row->name; ?>">
+								<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit' );?>::<?php echo htmlspecialchars($row->name); ?>">
 							<a href="<?php echo $link; ?>">
-								<?php echo $row->name; ?></a>
+								<?php echo htmlspecialchars($row->name); ?></a>
 								</span>
 							<?php
 						}
diff -aruN --binary 18/administrator/components/com_categories/admin.categories.php 20/administrator/components/com_categories/admin.categories.php
--- 18/administrator/components/com_categories/admin.categories.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_categories/admin.categories.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: admin.categories.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: admin.categories.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Categories
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -128,6 +128,16 @@
 	$section_name 	= '';
 	$content_add 	= '';
 	$content_join 	= '';
+
+	// ensure we have a good value for $filter_order
+	if (!in_array($filter_order, array('c.title', 'c.published', 'c.ordering', 'groupname', 'section_name', 'c.id'))) {
+		$filter_order = 'c.ordering';
+	}
+
+	if (intval($section) <= 0 && $section != 'com_content' && $filter_order == 'section_name') {
+		$filter_order = 'c.ordering';
+	}
+
 	$order 			= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';
 	if (intval( $section ) > 0) {
 		$table = 'content';
@@ -193,6 +203,7 @@
 		$content_add 	= ' , z.title AS section_name';
 		$content_join 	= ' LEFT JOIN #__sections AS z ON z.id = c.section';
 		$where 			= ' WHERE c.section NOT LIKE "%com_%"';
+
 		if ($filter_order == 'c.ordering'){
 			$order 			= ' ORDER BY  z.title, c.ordering '. $filter_order_Dir;
 		} else {
@@ -424,7 +435,7 @@
 
 	// Initialize variables
 	$db		 =& JFactory::getDBO();
-	$menu 		= JRequest::getCmd( 'menu', 'mainmenu', 'post' );
+	$menu 		= JRequest::getVar( 'menu', 'mainmenu', 'post', 'menutype' );
 	$menuid		= JRequest::getVar( 'menuid', 0, 'post', 'int' );
 	$redirect 	= JRequest::getCmd( 'redirect', '', 'post' );
 	$oldtitle 	= JRequest::getString( 'oldtitle', '', 'post' );
@@ -489,11 +500,14 @@
 	switch ( JRequest::getCmd('task') )
 	{
 		case 'go2menu':
-			$mainframe->redirect( 'index.php?option=com_menus&menutype='. $menu );
+			$mainframe->redirect('index.php?option=com_menus&menutype=' . $menu);
 			break;
 
 		case 'go2menuitem':
-			$mainframe->redirect( 'index.php?option=com_menus&menutype='. $menu .'&task=edit&id='. $menuid );
+			$mainframe->redirect(
+				'index.php?option=com_menus&menutype=' . $menu 
+				. '&task=edit&id='. $menuid 
+			);
 			break;
 
 		case 'apply':
diff -aruN --binary 18/administrator/components/com_contact/admin.contact.html.php 20/administrator/components/com_contact/admin.contact.html.php
--- 18/administrator/components/com_contact/admin.contact.html.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_contact/admin.contact.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.contact.html.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.contact.html.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Contact
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -114,12 +114,12 @@
 					<td>
 					<?php
 					if (JTable::isCheckedOut($user->get ('id'), $row->checked_out )) :
-						echo $row->name;
+						echo htmlspecialchars($row->name);
 					else :
 						?>
-						<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Contact' );?>::<?php echo $row->name; ?>">
+						<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Contact' );?>::<?php echo htmlspecialchars($row->name); ?>">
 						<a href="<?php echo $link; ?>">
-							<?php echo $row->name; ?></a> </span>
+							<?php echo htmlspecialchars($row->name); ?></a> </span>
 						<?php
 					endif;
 					?>
diff -aruN --binary 18/administrator/components/com_contact/admin.contact.php 20/administrator/components/com_contact/admin.contact.php
--- 18/administrator/components/com_contact/admin.contact.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_contact/admin.contact.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.contact.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.contact.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Contact
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -131,6 +131,11 @@
 		}
 	}
 
+	// sanitize $filter_order
+	if (!in_array($filter_order, array('cd.name', 'cd.published', 'cd.ordering', 'cd.access', 'category', 'user', 'cd.id'))) {
+		$filter_order = 'cd.ordering';
+	}
+
 	$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
 	if ($filter_order == 'cd.ordering'){
 		$orderby 	= ' ORDER BY category, cd.ordering';
diff -aruN --binary 18/administrator/components/com_content/admin.content.php 20/administrator/components/com_content/admin.content.php
--- 18/administrator/components/com_content/admin.content.php	2010-04-23 13:40:10.000000000 +0200
+++ 20/administrator/components/com_content/admin.content.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,7 +1,7 @@
 <?php
 
 /**
-* @version		$Id: admin.content.php 14401 2010-01-26 14:10:00Z louis $
+* @version		$Id: admin.content.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -87,10 +87,6 @@
 		ContentController::orderContent(1);
 		break;
 
-	//case 'showarchive' :
-	//	JContentController::viewArchive();
-	//	break;
-
 	case 'movesect' :
 		ContentController::moveSection();
 		break;
diff -aruN --binary 18/administrator/components/com_content/controller.php 20/administrator/components/com_content/controller.php
--- 18/administrator/components/com_content/controller.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_content/controller.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: controller.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: controller.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -75,9 +75,14 @@
 		//$where[] = "c.state >= 0";
 		$where[] = 'c.state != -2';
 
-		if (!$filter_order) {
+		// ensure we have a valid value for filter_order
+		if (!in_array($filter_order, array('c.title', 'c.state', 'frontpage', 'c.ordering', 'groupname',
+									'section_name', 'cc.title', 'author', 'c.created', 'c.hits', 'c.id')))
+		{
 			$filter_order = 'section_name';
+
 		}
+
 		if ($filter_order == 'c.ordering') {
 			$order = ' ORDER BY section_name, cc.title, c.ordering '. $filter_order_Dir;
 		} else {
@@ -203,142 +208,6 @@
 	}
 
 	/**
-	* Shows a list of archived articles
-	* @param int The section id
-	*/
-	function viewArchive()
-	{
-		global $mainframe;
-
-		// Initialize variables
-		$db						=& JFactory::getDBO();
-
-		$sectionid				= JRequest::getVar( 'sectionid', 0, '', 'int' );
-		$option					= JRequest::getCmd( 'option' );
-
-		$filter_order			= $mainframe->getUserStateFromRequest("$option.$sectionid.viewarchive.filter_order",		'filter_order',		'sectname',	'cmd');
-		$filter_order_Dir		= $mainframe->getUserStateFromRequest("$option.$sectionid.viewarchive.filter_order_Dir",	'filter_order_Dir',	'',			'word');
-		$catid					= $mainframe->getUserStateFromRequest("$option.$sectionid.viewarchive.catid",				'catid',			0,			'int');
-		$limit					= $mainframe->getUserStateFromRequest('global.list.limit',									'limit',			$mainframe->getCfg('list_limit'), 'int');
-		$limitstart				= $mainframe->getUserStateFromRequest("$option.$sectionid.viewarchive.limitstart",			'limitstart',		0,			'int');
-		$filter_authorid		= $mainframe->getUserStateFromRequest("$option.$sectionid.viewarchive.filter_authorid",		'filter_authorid',	0,			'int');
-		$filter_sectionid		= $mainframe->getUserStateFromRequest("$option.$sectionid.viewarchive.filter_sectionid",	'filter_sectionid',	0,			'int');
-		$search					= $mainframe->getUserStateFromRequest("$option.$sectionid.viewarchive.search",				'search',			'',			'string');
-		if (strpos($search, '"') !== false) {
-			$search = str_replace(array('=', '<'), '', $search);
-		}
-		$search = JString::strtolower($search);
-		$redirect				= $sectionid;
-
-		// A section id of zero means view all articles [all sections]
-		if ($sectionid == 0)
-		{
-			$where = array ('c.state 	= -1', 'c.catid	= cc.id', 'cc.section = s.id', 's.scope  	= "content"');
-			$filter = ' , #__sections AS s WHERE s.id = c.section';
-			$all = 1;
-		}
-		else
-		{
-			 //We are viewing a specific section
-			$where = array ('c.state 	= -1', 'c.catid	= cc.id', 'cc.section	= s.id', 's.scope	= "content"', 'c.sectionid= '.(int) $sectionid);
-			$filter = ' WHERE section = '.$db->Quote($sectionid);
-			$all = NULL;
-		}
-
-		// Section filter
-		if ($filter_sectionid > 0)
-		{
-			$where[] = 'c.sectionid = ' . (int) $filter_sectionid;
-		}
-		// Author filter
-		if ($filter_authorid > 0)
-		{
-			$where[] = 'c.created_by = ' . (int) $filter_authorid;
-		}
-		// Category filter
-		if ($catid > 0)
-		{
-			$where[] = 'c.catid = ' . (int) $catid;
-		}
-		// Keyword filter
-		if ($search)
-		{
-			$where[] = 'LOWER( c.title ) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
-		}
-
-		// TODO: Sanitise $filter_order
-		$filter_order_Dir = ($filter_order_Dir == 'ASC' ? 'ASC' : 'DESC');
-		$orderby = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', sectname, cc.name, c.ordering';
-		$where = (count($where) ? ' WHERE '.implode(' AND ', $where) : '');
-
-		// get the total number of records
-		$query = 'SELECT COUNT(*)' .
-				' FROM #__content AS c' .
-				' LEFT JOIN #__categories AS cc ON cc.id = c.catid' .
-				' LEFT JOIN #__sections AS s ON s.id = c.sectionid' .
-				$where;
-		$db->setQuery($query);
-		$total = $db->loadResult();
-
-		jimport('joomla.html.pagination');
-		$pagination = new JPagination($total, $limitstart, $limit);
-
-		$query = 'SELECT c.*, g.name AS groupname, cc.name, v.name AS author, s.title AS sectname' .
-				' FROM #__content AS c' .
-				' LEFT JOIN #__categories AS cc ON cc.id = c.catid' .
-				' LEFT JOIN #__sections AS s ON s.id = c.sectionid' .
-				' LEFT JOIN #__groups AS g ON g.id = c.access' .
-				' LEFT JOIN #__users AS v ON v.id = c.created_by' .
-				$where .
-				$orderby;
-		$db->setQuery($query, $pagination->limitstart, $pagination->limit);
-		$rows = $db->loadObjectList();
-
-		// If there is a database query error, throw a HTTP 500 and exit
-		if ($db->getErrorNum())
-		{
-			JError::raiseError( 500, $db->stderr() );
-			return false;
-		}
-
-		// get list of categories for dropdown filter
-		$query = 'SELECT c.id AS value, c.title AS text' .
-				' FROM #__categories AS c' .
-				$filter .
-				' ORDER BY c.ordering';
-		$lists['catid'] = ContentHelper::filterCategory($query, $catid);
-
-		// get list of sections for dropdown filter
-		$javascript = 'onchange="document.adminForm.submit();"';
-		$lists['sectionid'] = JAdminMenus::SelectSection('filter_sectionid', $filter_sectionid, $javascript);
-
-		$section = & JTable::getInstance('section');
-		$section->load($sectionid);
-
-		// get list of Authors for dropdown filter
-		$query = 'SELECT c.created_by, u.name' .
-				' FROM #__content AS c' .
-				' INNER JOIN #__sections AS s ON s.id = c.sectionid' .
-				' LEFT JOIN #__users AS u ON u.id = c.created_by' .
-				' WHERE c.state = -1' .
-				' GROUP BY u.name' .
-				' ORDER BY u.name';
-		$db->setQuery($query);
-		$authors[] = JHTML::_('select.option', '0', '- '.JText::_('Select Author').' -', 'created_by', 'name');
-		$authors = array_merge($authors, $db->loadObjectList());
-		$lists['authorid'] = JHTML::_('select.genericlist',  $authors, 'filter_authorid', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'created_by', 'name', $filter_authorid);
-
-		// table ordering
-		$lists['order_Dir']	= $filter_order_Dir;
-		$lists['order']		= $filter_order;
-
-		// search filter
-		$lists['search'] = $search;
-
-		ContentView::showArchive($rows, $section, $lists, $pagination, $option, $all, $redirect);
-	}
-
-	/**
 	* Compiles information to add or edit the record
 	*
 	* @param database A database connector object
@@ -604,7 +473,7 @@
 		$task		= JRequest::getCmd( 'task' );
 		$sectionid	= JRequest::getVar( 'sectionid', 0, '', 'int' );
 		$redirect	= JRequest::getVar( 'redirect', $sectionid, 'post', 'int' );
-		$menu		= JRequest::getVar( 'menu', 'mainmenu', 'post', 'cmd' );
+		$menu		= JRequest::getVar( 'menu', 'mainmenu', 'post', 'menutype' );
 		$menuid		= JRequest::getVar( 'menuid', 0, 'post', 'int' );
 		$nullDate	= $db->getNullDate();
 
@@ -763,11 +632,14 @@
 		switch ($task)
 		{
 			case 'go2menu' :
-				$mainframe->redirect('index.php?option=com_menus&menutype='.$menu);
+				$mainframe->redirect('index.php?option=com_menus&menutype=' . $menu);
 				break;
 
 			case 'go2menuitem' :
-				$mainframe->redirect('index.php?option=com_menus&menutype='.$menu.'&task=edit&id='.$menuid);
+				$mainframe->redirect(
+					'index.php?option=com_menus&menutype=' . $menu
+					. '&task=edit&id=' . $menuid
+				);
 				break;
 
 			case 'menulink' :
diff -aruN --binary 18/administrator/components/com_content/helper.php 20/administrator/components/com_content/helper.php
--- 18/administrator/components/com_content/helper.php	2010-04-23 13:40:10.000000000 +0200
+++ 20/administrator/components/com_content/helper.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: helper.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -84,6 +84,54 @@
 	}
 
 	/**
+	* Applies the content tag filters to arbitrary text as per settings for current user group
+	* @param text The string to filter
+	* @return string The filtered string
+	*/
+	function filterText( $text )
+	{
+		// Filter settings
+		jimport( 'joomla.application.component.helper' );
+		$config	= JComponentHelper::getParams( 'com_content' );
+		$user	= &JFactory::getUser();
+		$gid	= $user->get( 'gid' );
+
+		$filterGroups	=  $config->get( 'filter_groups' );
+		
+		// convert to array if one group selected
+		if ( (!is_array($filterGroups) && (int) $filterGroups > 0) ) { 
+			$filterGroups = array($filterGroups);
+		}
+
+		if (is_array($filterGroups) && in_array( $gid, $filterGroups ))
+		{
+			$filterType		= $config->get( 'filter_type' );
+			$filterTags		= preg_split( '#[,\s]+#', trim( $config->get( 'filter_tags' ) ) );
+			$filterAttrs	= preg_split( '#[,\s]+#', trim( $config->get( 'filter_attritbutes' ) ) );
+			switch ($filterType)
+			{
+				case 'NH':
+					$filter	= new JFilterInput();
+					break;
+				case 'WL':
+					$filter	= new JFilterInput( $filterTags, $filterAttrs, 0, 0, 0);  // turn off xss auto clean
+					break;
+				case 'BL':
+				default:
+					$filter	= new JFilterInput( $filterTags, $filterAttrs, 1, 1 );
+					break;
+			}
+			$text	= $filter->clean( $text );
+		} elseif(empty($filterGroups) && $gid != '25') { // no default filtering for super admin (gid=25)
+			$filter = new JFilterInput( array(), array(), 1, 1 );
+			$text	= $filter->clean( $text );
+		}
+		return $text;
+	}
+
+
+
+	/**
 	* Function to reset Hit count of an article
 	*
 	*/
diff -aruN --binary 18/administrator/components/com_cpanel/admin.cpanel.php 20/administrator/components/com_cpanel/admin.cpanel.php
--- 18/administrator/components/com_cpanel/admin.cpanel.php	2010-04-23 13:40:10.000000000 +0200
+++ 20/administrator/components/com_cpanel/admin.cpanel.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.cpanel.php 14401 2010-01-26 14:10:00Z louis $
+* @version		$Id: admin.cpanel.php 18130 2010-07-14 11:21:35Z louis $
 * @package		Joomla
 * @subpackage	Admin
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -20,6 +20,52 @@
 {
 	default:
 	{
+		// Check to see if the mootools upgrade plugin is enabled.
+		if (!JPluginHelper::getPlugin('system', 'mtupgrade')) {
+
+			// Only do the mtupgrade plugin check once per session.
+			$app = &JFactory::getApplication();
+			if (!$app->getUserState('com_cpanel.mtupgrade.checked')) {
+
+				// If it is not enabled, let's check to see if it is even installed.
+				$db = &JFactory::getDBO();
+				$db->setQuery(
+					'SELECT id' .
+					' FROM #__plugins' .
+					' WHERE folder = "system"' .
+					' AND element = "mtupgrade"'
+				);
+				$exists = (bool) $db->loadResult();
+
+				// If it is not installed, install it as disabled and raise a notice.
+				if (!$exists) {
+					$plg = & JTable::getInstance('plugin');
+					$plg->name = 'System - Mootools Upgrade';
+					$plg->ordering = 0;
+					$plg->folder = 'system';
+					$plg->iscore = 0;
+					$plg->access = 0;
+					$plg->client_id = 0;
+					$plg->element = 'mtupgrade';
+					$plg->published = 0;
+
+					// If unable to store the plugin, raise a notice.
+					if (!$plg->store()) {
+						JError::raiseNotice(500, $plg->getError() /*JText::sprintf('Unable to auto-install the Mootools Upgrade plugin.', $plg->getError())*/);
+					}
+					// Show a message stating that the plugin is now available.
+					else {
+						//$app->enqueueMessage(JText::_('Mootools Upgrade plugin available.'));
+					}
+				}
+
+				// Set the mtupgrade plugin checked flag for the session.
+				$app->setUserState('com_cpanel.mtupgrade.checked', true);
+			}
+
+
+		}
+
 		//set the component specific template file in the request
 		JRequest::setVar('tmpl', 'cpanel');
 		HTML_cpanel::display();
diff -aruN --binary 18/administrator/components/com_frontpage/admin.frontpage.php 20/administrator/components/com_frontpage/admin.frontpage.php
--- 18/administrator/components/com_frontpage/admin.frontpage.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_frontpage/admin.frontpage.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.frontpage.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.frontpage.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -135,6 +135,12 @@
 	}
 
 	$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
+
+	// ensure we have a good vale for $filter_order
+	if (!in_array($filter_order, array('c.title', 'c.state', 'fpordering', 'groupname', 'c.id', 'sect_name', 'cc.name', 'author'))) {
+		$filter_order = 'fpordering';
+	}
+
 	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', fpordering';
 
 	// get the total number of records
diff -aruN --binary 18/administrator/components/com_menus/classes/ilink.php 20/administrator/components/com_menus/classes/ilink.php
--- 18/administrator/components/com_menus/classes/ilink.php	2010-04-23 13:40:10.000000000 +0200
+++ 20/administrator/components/com_menus/classes/ilink.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: ilink.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: ilink.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Menus
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -44,7 +44,7 @@
 		}
 
 		if ($menutype) {
-			$this->_menutype = "&amp;menutype=".$menutype;
+			$this->_menutype = "&amp;menutype=" . JFilterInput::clean($menutype, 'menutype');
 		} else {
 			$this->_menutype = null;
 		}
@@ -115,12 +115,20 @@
 		$this->_output .= "<li".$last.">\n";
 
 		// Print the url
-		if ($this->_current->hasChildren()) {
-			$this->_output .= "<div class=\"".$classes."\"><span></span><a class=\"hasTip\" title=\"". JText::_( $this->_current->title ) ."::". JText::_( $this->_current->msg ) ."\">". JText::_( $this->_current->title ) ."</a></div>";
-		} else {
-			$this->_output .= "<div class=\"".$classes."\"><span></span><a class=\"hasTip\" href=\"index.php?option=com_menus&amp;task=edit&amp;type=component&amp;".$this->_current->url.$this->_cid.$this->_menutype."\" title=\"". JText::_( $this->_current->title ) ."::". JText::_( $this->_current->msg ) ."\">". JText::_( $this->_current->title ) ."</a></div>";
-		}
-
+		$this->_output .= '<div class="' . $classes . '"><span></span>'
+			. '<a class="hasTip" ';
+		if (! $this->_current->hasChildren()) {
+			$this->_output .= 'href="index.php?option=com_menus'
+				. '&amp;task=edit&amp;type=component&amp;'
+				. $this->_current->url . $this->_cid
+				. $this->_menutype . '" '
+			;
+		}
+		$this->_output .= 'title="' . JText::_($this->_current->title)
+			. '::' . JText::_($this->_current->msg) . '">'
+			. JText::_($this->_current->title) . '</a></div>'
+		;
+		
 		// Recurse through children if they exist
 		while ($this->_current->hasChildren())
 		{
